package utils;

import java.io.File;

import javax.swing.filechooser.FileFilter;

/**
 *  
 * @author jwdd
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/.
 */
public class ExtensionFileFilter extends FileFilter
{
	String description;

	String extensions[];

	public ExtensionFileFilter(String description, String extension)
	{
		this(description, new String[] { extension });
	}

	public ExtensionFileFilter(String description, String extensions[])
	{
		if(description == null)
		{
			this.description = extensions[0];
		}
		else
		{
			this.description = description;
		}
		this.extensions = (String[]) extensions.clone();
		toLower(this.extensions);
	}

	private void toLower(String array[])
	{
		for (int i = 0, n = array.length; i < n; i++)
		{
			array[i] = array[i].toLowerCase();
		}
	}

	public String getDescription()
	{
		return description;
	}

	public boolean accept(File f)
	{
		if(f.isDirectory())
		{
			return true;
		}
		else
		{
			String path = f.getAbsolutePath().toLowerCase();
			for (int i = 0, n = extensions.length; i < n; i++)
			{
				String extension = extensions[i];
				if((path.endsWith(extension) && (path.charAt(path.length() - extension.length() - 1)) == '.'))
				{
					return true;
				}
			}
		}
		return false;
	}
}
