package utils;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Image;
import java.awt.Rectangle;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.LinkedHashMap;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import com.sun.org.apache.xerces.internal.jaxp.DocumentBuilderFactoryImpl;
import com.sun.org.apache.xml.internal.serialize.OutputFormat;
import com.sun.org.apache.xml.internal.serialize.XMLSerializer;

/**
 *  
 * @author jwdd
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/.
 */
public class XMLBotones
{
	private static final String TAG_ROOT = "teclado";
	private static final String TAG_BOTON = "boton";
	// Codificacion
	private static final String XML_VERSION = "1.0";
	//private static final String XML_ENCODING = "UTF-8";
	private static final String XML_ENCODING = "iso-8859-1";
	// Varibles para la escritura
	private Document documentXML = null;
	private Element buttons = null;
	// Variables para la lectura
	private JButton tempButton = null; // Boton temporal
	private int nButton = 0;
	private int npos = 0;
	private JButton arrayButtons[] = null; // Array de botones
	private String strNodo = "";
	private final String sRUTAPICTOGRAMAS = "pict";
	private final String EXTENSION = "png";
	private boolean ispicto = false;
	private int tecladoWidth = 0;
	private int tecladoHeight = 0;
	private String sRutaImagen = "";

	public Dimension getLastKeyboardSize()
	{
		return new Dimension(tecladoWidth, tecladoHeight);
	}
	public String getImagen(){
		return sRutaImagen;
	}

	public JButton[] readConfigXML(String filename, String path)
	{
		Document document = null;
		tempButton = null;
		arrayButtons = null;
		nButton = 0;
		npos = 0;
		int nb = 0;

		try
		{
			DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
			File f = new File(path + File.separator + filename);
			document = builder.parse(f);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

		nButton = 0; // Contamos los el número de botones
		nb = countButtons(document); // Creamos un array para los jbuttons
		arrayButtons = new JButton[nb]; // Dimensionamos el array al número de
		XML2JButtons(document); // Llamo la función que crea el array de
		// jButtons

		if(nButton > 0) // Añado el último botón
		{
			arrayButtons[npos] = tempButton;
		}

		return arrayButtons;
	}

	private int countButtons(Node nodo)
	{
		if(nodo != null)
		{
			if(nodo.getNodeName() == "boton")
			{
				nButton++;
			}

			NodeList hijos = nodo.getChildNodes();
			for (int i = 0; i < hijos.getLength(); i++)
			{
				Node nodoNieto = hijos.item(i);
				countButtons(nodoNieto);
			}
		}

		return nButton;
	}

	private void XML2JButtons(Node nodo)
	{
		int value;
		String cadena = null;
		if(nodo != null)
		{
			// System.out.println("- Nombre del nodo: " + nodo.getNodeName());
			// System.out.println("- Valor del nodo    : " +
			// nodo.getNodeValue());

			if(!nodo.getNodeName().equals("#text"))
			{
				strNodo = nodo.getNodeName();
			}

			if(nodo.getNodeName().equals(TAG_ROOT))
			{
				
				NamedNodeMap attrs = nodo.getAttributes();
				
				for (int i = 0; i < attrs.getLength(); i++)
				{
					Attr attribute = (Attr) attrs.item(i);
					if(attribute.getName().equals("width"))
					{
						tecladoWidth = Integer.parseInt(attribute.getValue());
					}
					else if(attribute.getName().equals("height"))
					{
						tecladoHeight = Integer.parseInt(attribute.getValue());
					}
					else if (attribute.getName().equals("imagen")){
						sRutaImagen = attribute.getValue();
						
					}
				}

			}

			if(nodo.getNodeName().equals("boton"))
			{
				if(tempButton != null) // En caso de que no sea el primer boton
				{
					arrayButtons[npos] = tempButton;
					npos++;
				}

				tempButton = new JButton();
				//System.out.println("=== BOTON ===");
			}	
			
			else if(strNodo.equals("tipo"))
			{
				if(nodo.getNodeValue() != null && nodo.getNodeValue().length() != 0 && nodo.getNodeName().equals("#text"))
				{
					if(nodo.getNodeValue().equals("texto"))
					{
						tempButton.setIcon(null);
						tempButton.setName(null);
						ispicto = false;
					}
					else
					{
						tempButton.setBackground(Color.WHITE);
						tempButton.setText(null);
						ispicto = true;
					}
					//System.out.println(strNodo + " = " + nodo.getNodeValue());
					strNodo = "";
				}
				// System.out.println(strNodo + " = " + nodo.getNodeValue());
			}
			else if(strNodo.equals("pictograma"))
			{
				if((nodo.getNodeValue() != null) && (nodo.getNodeValue().length() != 0) && (nodo.getNodeName().equals("#text")))
				{
					if(ispicto)
					{
						int iancho = tempButton.getWidth();
						int ilargo = tempButton.getHeight();
						cadena = nodo.getNodeValue();
						String ruta = sRUTAPICTOGRAMAS + File.separator;
						ruta = ruta.concat(cadena);
						ruta = ruta.concat(".png");
						ImageIcon iPicto = new ImageIcon(ruta);
						Image img = iPicto.getImage();
						Image newimg = img.getScaledInstance(iancho, ilargo, java.awt.Image.SCALE_SMOOTH);
						ImageIcon newIcon = new ImageIcon(newimg);
						tempButton.setIcon(newIcon);
						tempButton.setName(cadena);
						tempButton.setBackground(Color.WHITE);
						tempButton.setText("");
						//System.out.println(strNodo + " = " + cadena);
						strNodo = "";
						ispicto = false;
					}
				}
			}
			else if(strNodo.equals("ancho"))
			{
				if(nodo.getNodeValue() != null && nodo.getNodeValue() != "" && nodo.getNodeName() == "#text")
				//if(nodo.getNodeValue() != null && nodo.getNodeValue().length() != 0 && nodo.getNodeName().equals("#text"))
				{
					value = Integer.valueOf(nodo.getNodeValue());
					int t = tempButton.getHeight();
					tempButton.setSize(value, t);
					//System.out.println(strNodo + " = " + nodo.getNodeValue());
					strNodo = "";
				}
			}
			else if(strNodo.equals("alto"))
			{
				if(nodo.getNodeValue() != null && nodo.getNodeValue().length() != 0 && nodo.getNodeName().equals("#text"))
				{
					value = Integer.valueOf(nodo.getNodeValue());
					int t = tempButton.getWidth();
					tempButton.setSize(t, value);
					//System.out.println(strNodo + " = " + nodo.getNodeValue());
					strNodo = "";
				}
			}
			
			else if(strNodo == "posx")
			{
				if(nodo.getNodeValue() != null && nodo.getNodeValue().length() != 0 && nodo.getNodeName().equals("#text"))
				{
					value = Integer.valueOf(nodo.getNodeValue());
					int w = tempButton.getWidth();
					int h = tempButton.getHeight();
					int y = tempButton.getBounds().y;
					tempButton.setBounds(new Rectangle(value, y, w, h));
					//System.out.println(strNodo + " = " + nodo.getNodeValue());
					strNodo = "";
				}
			}
			else if(strNodo == "posy")
			{
				if(nodo.getNodeValue() != null && nodo.getNodeValue().length() != 0 && nodo.getNodeName().equals("#text"))
				{
					value = Integer.valueOf(nodo.getNodeValue());
					int w = tempButton.getWidth();
					int h = tempButton.getHeight();
					int x = tempButton.getBounds().x;
					tempButton.setBounds(new Rectangle(x, value, w, h));
					//System.out.println(strNodo + " = " + nodo.getNodeValue());
					strNodo = "";
				}
			}

			
			
			else if(strNodo.equals("texto"))
			{
				if(nodo.getNodeValue() != null && nodo.getNodeValue().length() != 0 && nodo.getNodeName().equals("#text"))
				{
					cadena = nodo.getNodeValue();
					tempButton.setText(cadena);
				//	System.out.println(strNodo + " = " + nodo.getNodeValue());
					strNodo = "";
				}
			}
			else if(strNodo.equals("tamtexto"))
			{
				if(nodo.getNodeValue() != null && nodo.getNodeValue().length() != 0 && nodo.getNodeName().equals("#text"))
				{
					value = Integer.valueOf(nodo.getNodeValue());
					tempButton.setFont(new Font("sansserif", Font.PLAIN, value));
				//	System.out.println(strNodo + " = " + nodo.getNodeValue());
					strNodo = "";
				}
			}
			else if(strNodo.equals("tooltip"))
			{
				if(nodo.getNodeValue() != null && nodo.getNodeValue().length() != 0 && nodo.getNodeName().equals("#text"))
				{
					cadena = nodo.getNodeValue();
					tempButton.setToolTipText(cadena);
				//	System.out.println(strNodo + " = " + nodo.getNodeValue());
					strNodo = "";
				}
			}
			else if(strNodo.equals("colorfondo"))
			{
				if(nodo.getNodeValue() != null && nodo.getNodeValue().length() != 0 && nodo.getNodeName().equals("#text"))
				{
					value = Integer.valueOf(nodo.getNodeValue());
					tempButton.setBackground(new Color(value));
				//	System.out.println(strNodo + " = " + nodo.getNodeValue());
					strNodo = "";
				}
			}
			else if(strNodo == "colortexto")
			{
				if(nodo.getNodeValue() != null && nodo.getNodeValue().length() != 0 && nodo.getNodeName().equals("#text"))
				{
					value = Integer.valueOf(nodo.getNodeValue());
					tempButton.setForeground(new Color(value));
				//	System.out.println(strNodo + " = " + nodo.getNodeValue());
					strNodo = "";
				}
			}
			else if(strNodo == "secuencia")
			{
				if(nodo.getNodeValue() != null && nodo.getNodeValue().length() != 0 && nodo.getNodeName().equals("#text"))
				{
					value = Integer.valueOf(nodo.getNodeValue());
					tempButton.setMnemonic(value);
				//	System.out.println(strNodo + " = " + nodo.getNodeValue());
					strNodo = "";
				}
			}
			/*else if(strNodo == "posx")
			{
				if(nodo.getNodeValue() != null && nodo.getNodeValue().length() != 0 && nodo.getNodeName().equals("#text"))
				{
					value = Integer.valueOf(nodo.getNodeValue());
					int w = tempButton.getWidth();
					int h = tempButton.getHeight();
					int y = tempButton.getBounds().y;
					tempButton.setBounds(new Rectangle(value, y, w, h));
					System.out.println(strNodo + " = " + nodo.getNodeValue());
					strNodo = "";
				}
			}
			else if(strNodo == "posy")
			{
				if(nodo.getNodeValue() != null && nodo.getNodeValue().length() != 0 && nodo.getNodeName().equals("#text"))
				{
					value = Integer.valueOf(nodo.getNodeValue());
					int w = tempButton.getWidth();
					int h = tempButton.getHeight();
					int x = tempButton.getBounds().x;
					tempButton.setBounds(new Rectangle(x, value, w, h));
					System.out.println(strNodo + " = " + nodo.getNodeValue());
					strNodo = "";
				}
			}*/

			NodeList hijos = nodo.getChildNodes();
			for (int i = 0; i < hijos.getLength(); i++)
			{
				Node nodoNieto = hijos.item(i);
				XML2JButtons(nodoNieto);
			}
		}
	}

	public boolean newConfigXML(JFrame fframe, int tipo, int width, int height, JButton[] botones, String filename, String path, String fRutaImagen)
	{
		LinkedHashMap<String, String> info = null;
		String strXML = null;
		
		initDocumentXML(tipo, width, height, fRutaImagen); // Inicializo el documento XML

		int tam = botones.length;
		for (int i = 0; i < tam; i++) // Añado los botones
		{
			if(botones[i].isVisible())
			{
				info = infoJButton(botones[i]);
				addButtonXML(i, info);
			}
		}

		strXML = makeTextXML();
		//System.out.println(strXML); // Muestra el XML en pantalla
		return String2File(fframe, filename, path, strXML); // Guarda el XML en un fichero
		
	}

	public LinkedHashMap<String, String> infoJButton(JButton j)
	{
		LinkedHashMap<String, String> info = new LinkedHashMap<String, String>();

		if(j.getName() == null)
		{
			info.put("tipo", "texto");
			info.put("pictograma", "null"); // niobe
		}
		else
		{
			info.put("tipo", "pictograma");
			info.put("pictograma", j.getName());
		}

		info.put("ancho", String.valueOf(j.getWidth()));
		info.put("alto", String.valueOf(j.getHeight()));
		info.put("texto", j.getText());
		info.put("tamtexto", String.valueOf(j.getFont().getSize()));
		info.put("tooltip", j.getToolTipText());
		info.put("posx", String.valueOf(j.getBounds().x));
		info.put("posy", String.valueOf(j.getBounds().y));
		info.put("colorfondo", String.valueOf(j.getBackground().getRGB()));
		info.put("colortexto", String.valueOf(j.getForeground().getRGB()));
		info.put("secuencia", String.valueOf(j.getMnemonic()));

		return info;
	}

	public void initDocumentXML(int tipo, int w, int h, String fRuta) // Genera un documento
	// XML en memoria
	{
		try
		{
			// 1. Crear objeto DocumentBuilderFactory
			DocumentBuilderFactory dbFactory = DocumentBuilderFactoryImpl.newInstance();
			// 2. A partir del objeto DocumentBuilderFactory crear un objeto
			// DocumentBuilder
			DocumentBuilder docBuilder = dbFactory.newDocumentBuilder();
			// 3. Generar el documento XML
			documentXML = docBuilder.newDocument();
		}
		catch (Exception e)
		{
			System.out.println("Error : " + e);
		}

		// 4. Crear el elemento "descargas"
		buttons = documentXML.createElement(TAG_ROOT);
		buttons.setAttribute("width", String.valueOf(w));
		buttons.setAttribute("height", String.valueOf(h));
		buttons.setAttribute("tipo", String.valueOf(tipo));
		if (tipo == 2 ){
			// Si es teclado virtual 2, se guarda el nombre de la imagen asociada
			buttons.setAttribute("imagen", fRuta);
		}
		// 5. Agregar al documento principal
		documentXML.appendChild(buttons);
	}

	public void addButtonXML(int id, LinkedHashMap<String, String> info)
	// Añade un boton al XML
	{
		Element elemento;
		Element item;

		elemento = documentXML.createElement(TAG_BOTON);
		elemento.setAttribute("id", String.valueOf(id));
		// 3. Añadir elemento al documento
		buttons.appendChild(elemento);
		// a. Crear item
		item = documentXML.createElement("tipo");
		item.appendChild(documentXML.createTextNode(info.get("tipo").toString()));
		elemento.appendChild(item);

		item = documentXML.createElement("ancho");
		item.appendChild(documentXML.createTextNode(info.get("ancho").toString()));
		elemento.appendChild(item);

		item = documentXML.createElement("alto");
		item.appendChild(documentXML.createTextNode(info.get("alto").toString()));
		elemento.appendChild(item);

		item = documentXML.createElement("posx");
		item.appendChild(documentXML.createTextNode(info.get("posx").toString()));
		elemento.appendChild(item);

		item = documentXML.createElement("posy");
		item.appendChild(documentXML.createTextNode(info.get("posy").toString()));
		elemento.appendChild(item);

		item = documentXML.createElement("texto");
		if(info.get("texto") == null)
		{
			item.appendChild(documentXML.createTextNode(" "));
		}
		else
		{
			item.appendChild(documentXML.createTextNode(info.get("texto").toString()));
		}
		elemento.appendChild(item);

		item = documentXML.createElement("tamtexto");
		item.appendChild(documentXML.createTextNode(info.get("tamtexto").toString()));
		elemento.appendChild(item);

		item = documentXML.createElement("tooltip");
		if(info.get("tooltip") == null)
		{
			item.appendChild(documentXML.createTextNode(null));
		}
		else
		{
			item.appendChild(documentXML.createTextNode(info.get("tooltip").toString()));
		}
		elemento.appendChild(item);

		item = documentXML.createElement("pictograma");
		item.appendChild(documentXML.createTextNode(info.get("pictograma").toString()));
		elemento.appendChild(item);

		item = documentXML.createElement("colorfondo");
		item.appendChild(documentXML.createTextNode(info.get("colorfondo").toString()));
		elemento.appendChild(item);

		item = documentXML.createElement("colortexto");
		item.appendChild(documentXML.createTextNode(info.get("colortexto").toString()));
		elemento.appendChild(item);

		item = documentXML.createElement("secuencia");
		item.appendChild(documentXML.createTextNode(info.get("secuencia").toString()));
		elemento.appendChild(item);
	}

	private String makeTextXML() // Devuelve un string con el XML
	{
		StringWriter strWriter = null;
		XMLSerializer seliarizadorXML = null;
		OutputFormat formatoSalida = null;
		try
		{
			seliarizadorXML = new XMLSerializer();
			strWriter = new StringWriter();
			formatoSalida = new OutputFormat();
			// 1. Establecer el formato
			formatoSalida.setEncoding(XML_ENCODING);
			formatoSalida.setVersion(XML_VERSION);
			formatoSalida.setIndenting(true);
			formatoSalida.setIndent(4);
			// 2. Definir un objeto donde se generara el codigo
			seliarizadorXML.setOutputCharStream(strWriter);
			// 3. Aplicar el formato
			seliarizadorXML.setOutputFormat(formatoSalida);
			// 4. Serializar documento XML
			seliarizadorXML.serialize(documentXML);
			strWriter.close();
		}
		catch (IOException ioEx)
		{
			System.out.println("Error : " + ioEx);
		}
		return strWriter.toString();
	}

	public static boolean String2File(JFrame fframe, String filename, String path, String content)
	{
		FileWriter fichero = null;
		PrintWriter pw = null;

		try
		{
			// niobe 10 04 2012
			// Controlar si va a sobreescribir un fichero antes de guardar.
			
			File ffile = new File(path + File.separator + filename);

			if (ffile.exists()) // si ya existe el fichero
			  { 
				
				Object[] options = {Global.LANG.getString("si"),Global.LANG.getString("no")};
				int n = JOptionPane.showOptionDialog(
	        		    fframe,
	        		    Global.LANG.getString("preguntasobr"),
	        		    		Global.LANG.getString("confirmsobr"),
	        		    JOptionPane.YES_NO_OPTION,
	        		    JOptionPane.QUESTION_MESSAGE,
	        		    null,     //do not use a custom Icon
	        		    options,  //the titles of buttons
	        		    options[0]);
	        	
	        	if (n == 0){ // si elige que si quiere sobreescribir
	        		
	        		fichero = new FileWriter(path + File.separator + filename);
	    			pw = new PrintWriter(fichero);
	    			pw.println(content);
	    			return true;
	        	}
	        	else {
	        		return false;
	        	}
			  }
			else {// si no existe fichero con el mismo nombre

				// fin niobe 10 04 2012
				fichero = new FileWriter(path + File.separator + filename);
				pw = new PrintWriter(fichero);
				pw.println(content);
				return true;
			}
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		finally
		{
			try
			{
				if(null != fichero) fichero.close();
			}
			catch (Exception e2)
			{
				e2.printStackTrace();
			}
		}
		return false;
	}

	public static void main(String args[])
	{
		JButton[] aAuxiliar = new JButton[11];
		for (int i = 0; i < 10; i++)
		{
			// ImageIcon iColor = new ImageIcon("/tmp/playa.jpg");
			aAuxiliar[i] = new JButton("Boton" + i);
			aAuxiliar[i].setBackground(new Color(192, 192, 192));
			aAuxiliar[i].setForeground(new Color(100, 100, 100));
			aAuxiliar[i].setSize(100, 200);
			aAuxiliar[i].setToolTipText("Prueba tooltip");
		}
		ImageIcon iColor = new ImageIcon("/tmp/playa.jpg");
		aAuxiliar[10] = new JButton("Boton10", iColor);
		aAuxiliar[10].setText(null);
		aAuxiliar[10].setName("playa");
		aAuxiliar[10].setBackground(new Color(192, 192, 192));
		aAuxiliar[10].setForeground(new Color(100, 100, 100));
		aAuxiliar[10].setSize(100, 200);

		XMLBotones bt = new XMLBotones();

		//bt.newConfigXML(this, 1, 10, 20, aAuxiliar, "prueba.xml", "/tmp", null);

		// XMLBotones bt = new XMLBotones();
		//bt.readConfigXML("prueba.xml", "/tmp");
	}
}
